VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTerrainGroupList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum SpecialTypes
    Wall
    DamagedWall
    HeavilyDamagedWall
    MicrobeWall
    LavaWall
    Tube
    Bulldozed
    CommonRubble
    RareRubble
    Burn
End Enum

Private strTerrainType As String        ' Name describing the terrain type

Private numGroups As Long
Private Group() As CTileGroup

Public Sub AddTileGroup(newTileGroup As CTileGroup)
    Dim strPrefix As String

    ' **TODO** Might want to sort the new group into some category
    
    ' Modify the dimensions of certain groups
    strPrefix = Left$(newTileGroup.Name, 4)
    If strPrefix = "tube" Or strPrefix = "wall" Or strPrefix = "lavw" Or strPrefix = "micw" Then
        ' Change the dimensions of the group
        newTileGroup.SetDimensions 4, 4
    End If

    ' Allocate space for the new Tile Group
    ReDim Preserve Group(numGroups)
    
    ' Store the reference to the new Tile Group
    Set Group(numGroups) = newTileGroup
    
    numGroups = numGroups + 1
End Sub

Property Get Name() As String
    Name = strTerrainType
End Property

Property Let Name(terrainTypeName As String)
    strTerrainType = terrainTypeName
End Property

Property Get NumTileGroups() As Long
    NumTileGroups = numGroups
End Property

Property Get TileGroup(index As Long) As CTileGroup
    Set TileGroup = Group(index)
End Property

Public Function ReadTerrainGroups(lngFileNum As Long) As Long

End Function

Public Function WriteTerrainGroups(lngFileNum As Long) As Long

End Function
